<?/***********************************************************************
                           
                           Gubed - PHP Debugger                        
                     (c) 2002 - 2004 Linus McCabe                     
                                                                      
 This program is free software; you can redistribute it and/or modify 
 it under the terms of the GNU General Public License as published by 
 the Free Software Foundation; either version 2 of the License, or    
 (at your option) any later version.                                  
                                                                      
 This program is distributed in the hope that it will be useful,      
 but WITHOUT ANY WARRANTY; without even the implied warranty of       
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 GNU General Public License for more details.                         
                                                                      
 You should have received a copy of the GNU General Public License    
 along with this program; if not, write to the Free Software          
 Foundation, Inc.
 59 Temple Place, Suite 330
 Boston, MA  02111-1307  USA
  
************************************************************************/

   /* Initialize gbd globals */
   require_once(dirname(__FILE__).'/GubedGlobals.php');
  if(extension_loaded('tokenizer'))
      require_once(dirname(__FILE__).'/GubedParserTokenizer.php');
   else
      require_once(dirname(__FILE__).'/GubedParserPre42.php');

   set_time_limit(3600);
   $GLOBALS['gbd']['gbdPort'] = $gbdDebugPort;
   $GLOBALS['gbd']['gbdServer'] = $gbdDebugServer;

//    $GLOBALS['gbd']['gbdErrorhandling'] = $gbdErrorHandling;

   // Delay when running with display
   if(!isset($GLOBALS['gbd']['displaydelay']))
      $GLOBALS['gbd']['displaydelay'] = 300000;
   
   // Cachedir
   if(!isset($GLOBALS['gbd']['cachedir']))
      $GLOBALS['gbd']['cachedir'] = '';
   
   // If default tmpname was used to get tempdir, it will be a file right now...
   if(is_file($GLOBALS['gbd']['cachedir'])) {
      unlink($GLOBALS['gbd']['cachedir']);
      $GLOBALS['gbd']['cachedir'] = dirname($GLOBALS['gbd']['cachedir']) . DIRECTORY_SEPARATOR . 'gubedcache';
   }
      
   if($GLOBALS['gbd']['cachedir'] != '' && !file_exists($GLOBALS['gbd']['cachedir']))
      mkdir($GLOBALS['gbd']['cachedir']);

   if($GLOBALS['gbd']['cachedir'] != '' && substr($GLOBALS['gbd']['cachedir'], -strlen(DIRECTORY_SEPARATOR)) != DIRECTORY_SEPARATOR )
      $GLOBALS['gbd']['cachedir'] .= DIRECTORY_SEPARATOR;
      
   // Gubed internal time to deduct from script time
   if(!isset($GLOBALS['gbd']['gubedtime'])) {
      $GLOBALS['gbd']['gubedtime'] = 0;
      $GLOBALS['gbd']['parsetime'] = 0;
   }
      
   if(!isset($GLOBALS['gbd']['unparsed']))
      $GLOBALS['gbd']['unparsed'] = Array();
      
   // At certain pointes, the errorhandler should return immediately
   if(!isset($GLOBALS['gbd']['gbdNoHalt']))
      $GLOBALS['gbd']['gbdNoHalt'] = false;
      
   // Temporarily turns off debugging
   if(!isset($GLOBALS['gbd']['gbdNoDbg']))
      $GLOBALS['gbd']['gbdNoDbg'] = false;

   // Keeps track of wether current script should be required or included...
   if(!isset($GLOBALS['gbd']['gbdScriptRequire']))
      $GLOBALS['gbd']['gbdScriptRequire'] = 'include';

   // Breakpoints
   if(!isset($GLOBALS['gbd']['breakpoints']))
      $GLOBALS['gbd']['breakpoints'] = Array();
   if(!isset($GLOBALS['gbd']['conditionalbreakpoints']))
      $GLOBALS['gbd']['conditionalbreakpoints'] = Array();

   // Global no-debug files
   if(!isset($GLOBALS['gbd']['gbdNoDebug']))
      if(file_exists(dirname(__FILE__)."/gbdNoDebug.txt"))
         $GLOBALS['gbd']['gbdNoDebug'] = array_map('trim', file(dirname(__FILE__)."/gbdNoDebug.txt"));
      else
         $GLOBALS['gbd']['gbdNoDebug'] = Array();
               
   // Keeps track of what files are included once
   if(!isset($GLOBALS['gbd']['gbdIncludedOnce']))
      $GLOBALS['gbd']['gbdIncludedOnce'] = Array();
   
   // Keeps track of witch variables are watched
   if(!isset($GLOBALS['gbd']['gdbView']))
      $GLOBALS['gbd']['gdbView'] = Array();
      
   // Keeps track of included scripts
   if(!isset($GLOBALS['gbd']['gdbScripts']))
      $GLOBALS['gbd']['gdbScripts'] = Array();
      
   // Counter - keeps track of recursedepth
   if(!isset($GLOBALS['gbd']['gbdCount']))
      $GLOBALS['gbd']['gbdCount'] = 0;

   if(!isset($GLOBALS['gbd']['gbdErrorMask']))
      $GLOBALS['gbd']['gbdErrorMask'] = E_ALL;

   if(!isset($GLOBALS['gbd']['gbdSocket']))
      $GLOBALS['gbd']['gbdSocket'] = 0;

//   if(!isset($GLOBALS['gbd']['executiondepth']))
//      $GLOBALS['gbd']['executiondepth'] = Array();

   if(!isset($GLOBALS['gbd']['backtrace']))
      $GLOBALS['gbd']['backtrace'] = Array();
    
   // This function is called initially and establishes the connection to the debugging server.
   // After handshaking, the name and source (if needed) is sent to the server.
   function gbdInitialize($gbdThisScript, $gbdTimer) {
      restore_error_handler();
  
      $intCnt = 0;
      if(!$GLOBALS['gbd']['gbdSocket']) {
         $GLOBALS['gbd']['gbdSocket'] = @fsockopen($GLOBALS['gbd']['gbdServer'], $GLOBALS['gbd']['gbdPort'], $errno, $errstr, 10);

         if(!$GLOBALS['gbd']['gbdSocket']) {
            echo "Unable to connect to debug server on {$GLOBALS['gbd']['gbdServer']}:{$GLOBALS['gbd']['gbdPort']}. Make sure your client (and proxy if you need it) is started, properly configured and waiting for connections";
            die();
         }
         
         socket_set_timeout($GLOBALS['gbd']['gbdSocket'], 3600, 0);
         socket_set_blocking($GLOBALS['gbd']['gbdSocket'], true);
         $gbdCommand = fgets($GLOBALS['gbd']['gbdSocket'], 256);
         fgets($GLOBALS['gbd']['gbdSocket'], 256);
         if($gbdCommand == "die")
           die();
         
         socket_set_timeout($GLOBALS['gbd']['gbdSocket'], 5, 0);
          
         gbdSendCommand("sendbreakpoints", "");

         if(!isset($GLOBALS['gbd']['gbdLeap'])) {
            $GLOBALS['gbd']['gbdLeap'] = false;
            gbdSendCommand("getrunmode", "");
         }
      }

      if($GLOBALS['gbd']['gbdSocket']) {

         if(!isset($GLOBALS['gbd']['gbdPhpOrigCode'][$gbdThisScript]))
            $GLOBALS['gbd']['gbdPhpOrigCode'][$gbdScriptname] = "";
         
         // If this line is activated, leap mode will show every single file it enteres (bad performance)
         // But if it's not, wx-client wont update its sourcecodes when changes have been made.. hmmmm
         if(!$GLOBALS['gbd']['gbdLeap'])
            gbdSendCommand("initialize", "{$gbdThisScript}:" .  md5($GLOBALS['gbd']['gbdPhpOrigCode'][$gbdThisScript]));
         gbdSendCommand("unparsed", gbdFixPath($gbdThisScript));
         gbdSendCommand("parsetime", $gbdThisScript . ':' . sprintf("%.2f", $gbdTimer));
         $GLOBALS['gbd']['unparsed'][$gbdThisScript] = true;

      } else {
         print("Unable to connect to debugging socket ($errno): $errstr\n<br>");
         die;
      }

      // set error reporting
      error_reporting(E_ALL);
      set_error_handler("gbdHandleError");

   }


   // This is the core of the debugging. It should be called every other statement.
   // It sends info to the server about what line it's at and asks for further instructions.
   // Then it performs some command or continues the script...
   function gbdGubed($gbdScriptname, $gbdLine, &$gbdVars, $gbdNextInst) {

      if($GLOBALS['gbd']['gbdNoDbg'])
        return 'return true;';
        
      $gbdTempTimer = gbdGetmicrotime();
        
      if($gbdLine == "")
         $gbdLine = 0;
      $gbdLine--;

      $GLOBALS['gbd']['gbdPrevScript'] = $gbdScriptname;

      if(count($GLOBALS['gbd']['breakpoints']) > 0 && array_key_exists($gbdScriptname.':'.$gbdLine, $GLOBALS['gbd']['breakpoints'])) {
         $GLOBALS['gbd']['gbdLeap'] = false;
         gbdSendCommand("forcebreak", gbdFixPath($gbdScriptname) . ":{$gbdLine}");
      }
      
      // Backtrace handling
      $gbdFunction = "";
      $gbdClass = "";
      
      // If our PHP version supports backtrace, get it and build one for displaying
      if(function_exists('debug_backtrace'))
         $gbdBackTrace = debug_backtrace();
      else
         $gbdBackTrace = Array();
         
      if(isset($gbdBackTrace[1]) &&  isset($gbdBackTrace[1]['function']) &&  $gbdBackTrace[1]['function'] != 'eval') {
         $gbdFunction = $gbdBackTrace[1]['function'];
         if(isset($gbdBackTrace[1]['class']))
            $gbdClass = $gbdBackTrace[1]['class'];
         
         //if(count($GLOBALS['gbd']['backtrace']) > 0)
            //$GLOBALS['gbd']['backtrace'][count($GLOBALS['gbd']['backtrace']) - 1]['line'] = $gbdBackTrace[1]['line'];
       }
       if(!isset($GLOBALS['gbd']['executiondepth']) || end($GLOBALS['gbd']['executiondepth']) < count($gbdBackTrace))  {
         array_push($GLOBALS['gbd']['backtrace'], 
                          Array(
                              'file' => $gbdScriptname, 
                              'class' => $gbdClass,
                              'function' => $gbdFunction,
                              ));
         $GLOBALS['gbd']['executiondepth'][] = count($gbdBackTrace);
       }   
       
       while(count($GLOBALS['gbd']['executiondepth']) > 0 && end($GLOBALS['gbd']['executiondepth']) > count($gbdBackTrace)) {
         array_pop($GLOBALS['gbd']['backtrace']);
         array_pop($GLOBALS['gbd']['executiondepth']);
       } 
       if(count($GLOBALS['gbd']['backtrace']) > 0)
         $GLOBALS['gbd']['backtrace'][count($GLOBALS['gbd']['backtrace']) - 1]['line'] = $gbdLine + 1;
   
       if(isset($GLOBALS['gbd']['executionhaltdepth']) && end($GLOBALS['gbd']['executiondepth']) <= $GLOBALS['gbd']['executionhaltdepth']) {
         unset($GLOBALS['gbd']['executionhaltdepth']);
         $GLOBALS['gbd']['gbdLeap'] = false;
       }
      
      // If we have conditional breakpoints
      $GLOBALS['gbd']['imported'] = false;
      if(count($GLOBALS['gbd']['conditionalbreakpoints']) > 0)
      {
         // Get the calling function's scope here
         extract($gbdVars);
         $GLOBALS['gbd']['imported'] = true;
         
         $GLOBALS['gbd']['gbdNoHalt'] = true;
         $GLOBALS['gbd']['gbdNoDbg'] = true;
         
         // Loop through them and check if they are fulfilled
         foreach ($GLOBALS['gbd']['conditionalbreakpoints'] as $gbdK => $gdbCondition) { //$gbdK => $gbdV) {
            // If we're in the right function/class
            if(($gdbCondition['function'] == '' || $gdbCondition['function'] == $gbdFunction)
            && ($gdbCondition['class'] == '' || $gdbCondition['class'] == $gbdClass)
            && ($gdbCondition['filename'] == '' || $gdbCondition['filename'] == $gbdScriptname)) {
             
               // Make sure the expression parses ok
               ob_start();
               $gbdV = eval(" return 1; return {$gdbCondition['expression']};");
               ob_end_clean();
               if($gbdV) {
                  $gbdV  = eval("return {$gdbCondition['expression']};");
                  
                  // Depending on what type of conditional bp this is:
                  if ($gdbCondition['type'] == 'change' && $gbdV != $gdbCondition['value']) {
                  // If the condition was changed, break execution
                     $GLOBALS['gbd']['gbdLeap'] = false;
                     gbdSendCommand('conditionalbreak', $gdbCondition['condition']);
                     gbdSendCommand('showcondition', $gdbCondition['condition'] . '^' . $gbdV);
                  } else if($gdbCondition['type'] != 'change' && $gbdV) {
                     // If the condition is true, break execution
                     $GLOBALS['gbd']['gbdLeap'] = false;
                     gbdSendCommand('conditionalbreak', $gdbCondition['condition']);
                     gbdSendCommand('showcondition', $gdbCondition['condition'] . '^' . $gbdV);
                  } else if(($GLOBALS['gbd']['gbdLeap'] == false)){
                     // Breakpoint not fulfilled, If we're not leaping tell the client...
                     gbdSendCommand('showcondition', $gdbCondition['condition'] . '^' . $gbdV);
                  }
                  $GLOBALS['gbd']['conditionalbreakpoints'][$gbdK]['value'] = $gbdV;
               } else {
                  // If they didnt parse, send error msg
                  if($GLOBALS['gbd']['gbdLeap'] == false)
                     gbdSendCommand('showcondition', $gdbCondition['condition'].'^-');
               }
            }
         }
         $GLOBALS['gbd']['gbdNoHalt'] = false;
         $GLOBALS['gbd']['gbdNoDbg'] = false;
      }

      if($GLOBALS['gbd']['gbdLeap'] == true) {
         socket_set_blocking($GLOBALS['gbd']['gbdSocket'], false);
         $gbdCommand = fgets($GLOBALS['gbd']['gbdSocket'], 256);
         socket_set_blocking($GLOBALS['gbd']['gbdSocket'], true);
         if($gbdCommand == "") {
            $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
            return 'return true;';
         }
      }

      // If we're in a script we really shouldnt debug, return immediately
      if(gbdCheckNoDebug($gbdScriptname)) {
         gbdSendCommand("status", "Shoudnt be here: {$gbdScriptname}, {$gbdLine}");
         $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
         return 'return true;';
      }

      $gbdReturnString = "";
      $gbdPrevline = "";
      $gbdMicroTime = gbdGetmicrotime();
      
      gbdSendCommand("commandme", gbdFixPath($gbdScriptname) .":{$gbdLine}");

      while(1) {
         if(!isset($gbdCommand))
            $gbdCommand = fgets($GLOBALS['gbd']['gbdSocket'], 256);
         if($gbdCommand !== false) {

            $gbdCommand = trim($gbdCommand);

            if($gbdCommand != "") {
               $gbdData = trim(fgets($GLOBALS['gbd']['gbdSocket'], 256));
            }

            switch($gbdCommand) {
               case 'next':
                /****c* Client.to.Script/next
                  * NAME
                  *    next
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to execute the next instruction and proceed to the next one.
                  *     This command will step into function calls and include files. 
                  *
                  * SEE ALSO
                  *     stepover, skip, stepout
                  ****/
                  $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
                  return 'return true;';
                  
               case 'stepover':
                /****c* Client.to.Script/stepover
                  * NAME
                  *    stepover
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to execute the next instruction and proceed to the next one.
                  *     This command will not step into function calls and include files.
                  *
                  * SEE ALSO
                  *     next, skip, stepout
                  ****/
                  $GLOBALS['gbd']['executionhaltdepth'] = end($GLOBALS['gbd']['executiondepth']);
                  $GLOBALS['gbd']['gbdLeap'] = true;
                  $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
                  return 'return true;';

               case 'stepout':
                /****c* Client.to.Script/stepout
                  * NAME
                  *    stepout
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to execute the rest of the instructions in the current function
                  *     or include file and halt again when it reaches the calling/including place.
                  *
                  * SEE ALSO
                  *     next, skip, stepover
                  ****/
                  if(count($GLOBALS['gbd']['executiondepth']) > 1) {
                     end($GLOBALS['gbd']['executiondepth']);
                     $GLOBALS['gbd']['executionhaltdepth'] = prev($GLOBALS['gbd']['executiondepth']);
                  } else
                     $GLOBALS['gbd']['executionhaltdepth'] = end($GLOBALS['gbd']['executiondepth']);
                  $GLOBALS['gbd']['gbdLeap'] = true;
                  $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
                  return 'return true;';
                  
               case 'pause':
                /****c* Client.to.Script/pause
                  * NAME
                  *    pause
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to halt and await further commands
                  *
                  * SEE ALSO
                  *     rundisplay, runnodisplay
                  ****/
               case 'rundisplay':
                /****c* Client.to.Script/rundisplay
                  * NAME
                  *    rundisplay
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to constantly tell the client about the current line of execution and
                  *     update watches, etc. As if the user was constantly pressing 'next'.
                  *
                  * SEE ALSO
                  *     pause, runnodisplay, setdisplaydelay
                  ****/
                  $GLOBALS['gbd']['gbdLeap'] = false;
                  break;

               case 'runnodisplay':
              /****c* Client.to.Script/runnodisplay
                  * NAME
                  *    runnodisplay
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to execute as fast as possible. Watches and current position
                  *     won't be updated until the script is paused or it enters run mode.
                  *
                  * SEE ALSO
                  *     rundisplay, pause
                  ****/ 
                  $GLOBALS['gbd']['gbdLeap'] = true;
                  break;

               case 'die':
              /****c* Client.to.Script/die
                  * NAME
                  *    die
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to die. Execution will stop immediately.
                  *
                  * SEE ALSO
                  *     pause
                  ****/ 
                  $GLOBALS['gbd']['buffer'] = ob_get_contents(); 
                  ob_end_clean();
                  die;

               case 'skip':
              /****c* Client.to.Script/skip
                  * NAME
                  *    skip
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to skip the next instruction as if it wasn't there and move on to the next one.
                  *
                  * SEE ALSO
                  *     next, stepover, stepout
                  ****/ 
                  $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
                  return 'return false;';

               case 'conditionalbreakpoint':
              /****c* Client.to.Script/conditionalbreakpoint
                  * NAME
                  *    coconditionalbreakpoint
                  *
                  * ARGS
                  *    * filename - only break if the condition is true in this file (optional)
                  *    * class - only break if the condition is true and in a method of an object of this class (optional)
                  *    * function - only break if the condition is true and in a function name like this (optional)
                  *    * type - either "change" or "true", ie break on change or break when true
                  *    * expression - what expression to evaluate, for example ($a == 12)
                  *      
                  * DESCRIPTION
                  *     Adds a conditional breakpoint
                  *
                  *     Note: unlike most other commands, the arguments are separated with a ^, not a colon
                  *
                  * SEE ALSO
                  *     clearconditionalbreakpoint, breakpoint
                  ****/ 
                  $GLOBALS['gbd']['gbdNoHalt'] = true;
                  $GLOBALS['gbd']['gbdNoDbg'] = true;
                  
                  // Make sure it parses ok
                  $gbdTmp = split('\^', substr($gbdData, 1), 5);
                  
                  ob_start();
                  $gbdV = eval(" return 1; return {$gbdTmp[4]};");
                  ob_end_clean();
                  if($gbdV) {
                     $gbdV = eval("return {$gbdTmp[4]};");
                     
                     $GLOBALS['gbd']['conditionalbreakpoints'][$gbdData]['condition'] =  $gbdData;
                     $GLOBALS['gbd']['conditionalbreakpoints'][$gbdData]['filename'] = $gbdTmp[0];
                     $GLOBALS['gbd']['conditionalbreakpoints'][$gbdData]['class'] =  $gbdTmp[1];
                     $GLOBALS['gbd']['conditionalbreakpoints'][$gbdData]['function'] = $gbdTmp[2];
                     $GLOBALS['gbd']['conditionalbreakpoints'][$gbdData]['value'] = $gbdV;
                     $GLOBALS['gbd']['conditionalbreakpoints'][$gbdData]['type'] = $gbdTmp[3];
                     $GLOBALS['gbd']['conditionalbreakpoints'][$gbdData]['expression'] = $gbdTmp[4];

                     gbdSendCommand('showcondition', $gbdData . '^' . $gbdV);
                  }
                  else
                     gbdSendCommand("status", "Invalid expression");
                     
                  $GLOBALS['gbd']['gbdNoHalt'] = false;
                  $GLOBALS['gbd']['gbdNoDbg'] = false;                     
                  break;
                  
               case 'clearconditionalbreakpoint':
              /****c* Client.to.Script/clearconditionalbreakpoint
                  * NAME
                  *    clearconditionalbreakpoint
                  *
                  * ARGS
                  *    * filename - same as when the breakpoint was added
                  *    * class - same as when the breakpoint was added
                  *    * function - same as when the breakpoint was added
                  *    * type - same as when the breakpoint was added
                  *    * expression - same as when the breakpoint was added
                  *      
                  * DESCRIPTION
                  *     Removes a conditional breakpoint
                  *
                  *     Note: unlike most other commands, the arguments are separated with a ^, not a colon
                  *
                  * SEE ALSO
                  *     conditionalbreakpoint, clearpoint
                  ****/ 
                  unset($GLOBALS['gbd']['conditionalbreakpoints'][$gbdData]);
                  break;

               case 'breakpoint':
                  /****c* Client.to.Script/breakpoint
                  * NAME
                  *    breakpoint
                  *
                  * ARGS
                  *    filename - file where the breakpoint should be located
                  *    line - what line the breakpoint is at
                  *
                  * DESCRIPTION
                  *    breakpoint tells the sctipt to set a breakpoint in the specified
                  *    file on the specified line.   
                  *
                  *    The script might reply with a clearbreakpoint command in
                  *     case the filename is illegal.
                  * 
                  * SEE ALSO
                  *   clearbreakpoint, conditionalbreakpoint
                  ****/ 
                  // Data: filename:line
                  $gbdTmp = substr($gbdData, 0, strrpos($gbdData, ':'));
                  if(!file_exists($gbdTmp)) {
                     gbdSendCommand('clearbreakpoint', $gbdData);
                     gbdSendCommand('status', "File {$gbdTmp} does not exist!");
                  } else
                     $GLOBALS['gbd']['breakpoints'][$gbdData] = true;
                  break;

               case 'clearpoint':
              /****c* Client.to.Script/clearpoint
                  * NAME
                  *    clearpoint
                  *
                  * ARGS
                  *    filename - file where the breakpoint should be located
                  *    line - what line the breakpoint is at
                  *      
                  * DESCRIPTION
                  *     Removes a breakpoint
                  *
                  * SEE ALSO
                  *     breakpoint, clearconditionalbreakpoint
                  ****/ 
                  unset($GLOBALS['gbd']['breakpoints'][$gbdData]);
                  break;

               case 'sendactiveline':
              /****c* Client.to.Script/sendactiveline
                  * NAME
                  *    sendactiveline
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to send the currently active file and line 
                  *
                  * SEE ALSO
                  *
                  ****/ 
                  gbdSendCommand("setactiveline", gbdFixPath($gbdScriptname) .":{$gbdLine}");
                  break;

               case 'sendprotocolversion':
              /****c* Client.to.Script/sendprotocolversion
                  * NAME
                  *    sendprotocolversion
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to send it's protocol version
                  *
                  * SEE ALSO
                  *     protocolversion
                  ****/ 
                  gbdSendCommand("protocolversion", $GLOBALS['gbdProtocolVersion']);
                  break;

               case 'reinitialize':
              /****c* Client.to.Script/reinitialize
                  * NAME
                  *    reinitialize
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to reinitialize, the client can request this action if it was closed
                  *     down and reopened during script execution (can happen when the proxy is used)
                  *     Or if the script tells the client to show a line that it doesent know of (and the source
                  *     can't be loaded form disk)
                  *
                  * SEE ALSO
                  *     initialize
                  ****/ 
                  gbdSendCommand("initialize", gbdFixPath($gbdScriptname) . ':' .  md5($GLOBALS['gbd']['gbdPhpOrigCode'][$gbdScriptname]));
                  break;

               case 'havesource':
              /****c* Client.to.Script/havesource
                  * NAME
                  *    havesource
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     During initialization, the client tells the script what file is to be entered and
                  *     the client responds with a 'havesource' if it already knows about the source
                  *     of the file. 
                  *
                  * SEE ALSO
                  *     initialize, sendsource
                  ****/ 
                  gbdSendCommand("setactiveline", gbdFixPath($gbdScriptname) .":{$gbdLine}");
                  break;

               case 'sendsource':
              /****c* Client.to.Script/sendsource
                  * NAME
                  *    sendsource
                  *
                  * ARGS
                  *    * filename - what source is requested
                  *      
                  * DESCRIPTION
                  *     During initialization, the client tells the script what file is to be entered and
                  *     the client responds with a 'sendsource' if it wants the script to send the sourcecode
                  *     of the file. 
                  *
                  * SEE ALSO
                  *     havesource
                  ****/ 
                  if(isset($GLOBALS['gbd']['gbdPhpOrigCode'][$gbdData])) {
                     gbdSendCommand("source", "{$gbdData}:{$GLOBALS['gbd']['gbdPhpOrigCode'][$gbdData]}");
                     gbdSendCommand("setactiveline", gbdFixPath($gbdScriptname) . ":{$gbdLine}");
                  }
                  break;

               case 'setvariable':
              /****c* Client.to.Script/setvariable
                  * NAME
                  *    setvariable
                  *
                  * ARGS
                  *    expression - php expression to be executed, for example "$t = 5" to set a variable.
                  *      
                  * DESCRIPTION
                  *     Tells the script about an expression that needs to be executed. Mainly to set contents of
                  *     variables.
                  *
                  * SEE ALSO
                  *
                  ****/ 
                  $gbdLine++; // Since we decreased it earlier, wh have to increase it again...
                  
                  // Testig this can give parser errors...
                  ob_start();
                  $gbdTest = eval("return 1; {$gbdData};");
                  ob_end_clean();
                   
                  if($gbdTest) {
                     $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
                     return '$GLOBALS["gbd"]["gbdNoHalt"] = true;'
                       . $gbdData .'; '
                       . '$GLOBALS["gbd"]["gbdNoHalt"] = false;'
                       . 'return eval(gbdGubed("'.$gbdScriptname.'",' . $gbdLine . ', get_defined_vars(), "' . $gbdNextInst . '"));';
                  }
                  
                  $gbdNewValue = substr($gbdData, strpos($gbdData, '=') + 1);
                  $gbdData = substr($gbdData, 0, strpos($gbdData, '='));
                  //echo "'$gbdData' '$gbdNewValue'<br>";
                  $GLOBALS['gbd']['gubedtime'] += gbdGetmicrotime() - $gbdTempTimer;
                  return  $gbdData . '="' . addslashes($gbdNewValue) . '"; return eval(gbdGubed("'.$gbdScriptname.'",' . $gbdLine . ', get_defined_vars(), "' . $gbdNextInst . '"));';

               case 'getwatch':
              /****c* Client.to.Script/getwatch
                  * NAME
                  *    getwatch
                  *
                  * ARGS
                  *    * expression - expression to watch, for example "$t" to watch the variable "t$"
                  *      
                  * DESCRIPTION
                  *     Requests the value of a watch
                  *
                  * SEE ALSO
                  *     getvariable
                  ****/ 
               case 'getvariable':
              /****c* Client.to.Script/getvariable
                  * NAME
                  *    getvariable
                  *
                  * ARGS
                  *    * expression - expression to get value of, for example "$t"
                  *      
                  * DESCRIPTION
                  *     Requests the value/result of an expression
                  *
                  * SEE ALSO
                  *     getwatch
                  ****/ 
                  if($GLOBALS['gbd']['imported'] == false) {
                     $GLOBALS['gbd']['imported'] = true;
                     extract($gbdVars);
                  }
                     
                  $GLOBALS['gbd']['gbdNoHalt'] = true;
                  $GLOBALS['gbd']['gbdNoDbg'] = true;
                  // In case the user decided to watch $GLOBALS - we hide the gbd ones (Don't wanna send the sources all the time...)
                  $gbdGubedOrigCode = $GLOBALS['gbd']['gbdPhpOrigCode'];
                  $gbdGubedCode = $GLOBALS['gbd']['gbdPhpCode'];
                  
                  unset($GLOBALS['gbd']['gbdPhpOrigCode']);
                  unset($GLOBALS['gbd']['gbdPhpCode']);

                  ob_start();
                  $gbdEval = "
                        \$gbdTemp = {$gbdData};
                        if(ob_get_length() > 0) {
                          \$gbdOutput = ob_get_contents();
                          ob_clean();
                          echo serialize(Array('return' => \$gbdTemp, 'output' => \$gbdOutput)); 
                        } else {
                          if(!isset(\$gbdTemp))
                            return -1;
                          echo serialize(\$gbdTemp);
                        }
                        return 1;
                     "; 
                  $gbdOk = eval($gbdEval);
                  $gbdValue = ob_get_contents();
                  ob_end_clean();
                  
                  if(!$gbdOk) {
                     $gbdValue = "!";

                  } elseif($gbdOk == -1)
                     $gbdValue = "-";

                  if($gbdCommand == 'getwatch')
                     gbdSendCommand("watch", "s:".(strlen($gbdData)).":\"". $gbdData ."\";{$gbdValue}");
                  else
                     gbdSendCommand("variable", "s:".(strlen($gbdData)).":\"". $gbdData ."\";{$gbdValue}");
                  
                  // Put the Gubed globals back
                  $GLOBALS['gbd']['gbdPhpOrigCode'] = $gbdGubedOrigCode;
                  $GLOBALS['gbd']['gbdPhpCode'] = $gbdGubedCode;
                  unset($gbdGubedOrigCode);
                  unset($gbdGubedCode);
                  $GLOBALS['gbd']['gbdNoHalt'] = false;
                  $GLOBALS['gbd']['gbdNoDbg'] = false;
                  break;

               case 'sendbacktrace':
              /****c* Client.to.Script/sendbacktrace
                  * NAME
                  *    sendbacktrace
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to send the current backtrace
                  *
                  * SEE ALSO
                  *
                  ****/ 
                  $gbdTmp = serialize(array_reverse($GLOBALS['gbd']['backtrace']));
                  gbdSendCommand("backtrace", substr($gbdTmp, 5, strlen($gbdTmp) - 6));
                  break;
                                    
               case 'sendallvariables':
              /****c* Client.to.Script/sendallvariables
                  * NAME
                  *    sendallvariables
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells the script to send the current scope
                  *
                  * SEE ALSO
                  *
                  ****/ 
                  $gbdVarsCompact = $gbdVars;// gbdArrayCompact($gbdVars);
                  unset($gbdVarsCompact['gbd']);
                  $gbdVarsCompact = serialize($gbdVarsCompact);
                  gbdSendCommand("variable", "s:".(strlen('Current Scope')).":\"". 'Current Scope' ."\";{$gbdVarsCompact}");

                  unset($gbdVarsCompact);
                  break;

               case 'sentwatches':
              /****c* Client.to.Script/sentwatches
                  * NAME
                  *    sentwatches
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     The script confirms that all watches were received
                  *
                  * SEE ALSO
                  *
                  ****/ 
                  gbdSendCommand("sentwatches", $gbdData);
                  break;

               case 'setdisplaydelay':
              /****c* Client.to.Script/setdisplaydelay
                  * NAME
                  *    setdisplaydelay
                  *
                  * ARGS
                  *    * newdelay - new delay in ms to wait between each instruction in run mode
                  *      
                  * DESCRIPTION
                  *     Set the display delay when in run mode. Note that setting this to zero does not
                  *     mean rundisplay == runnodisplay, rundisplay will still be slower due to watch
                  *     updates and other things.
                  *
                  * SEE ALSO
                  *     rundisplay
                  ****/ 
                  if(is_numeric($gbdData))
                     $GLOBALS['gbd']['displaydelay'] = $gbdData * 10000;
                  else
                     gbdSendCommand("status", "Illegal delay");
                  break;

               case 'seterrormask':
              /****c* Client.to.Script/seterrormask
                  * NAME
                  *    seterrormask
                  *
                  * ARGS
                  *    * errormask - the type of errors that should halt execution
                  *      
                  * DESCRIPTION
                  *     Sets the errormask, a combination of
                  *     * E_WARNING (2)
                  *     * E_NOTICE (8)
                  *     * E_USER_ERROR (256)
                  *     * E_USER_WARNING (512)
                  *     * E_USER_NOTICE (1024)
                  *
                  *     Other PHP error types are not handable
                  *
                  * SEE ALSO
                  *     error, http://se.php.net/manual/en/ref.errorfunc.php#errorfunc.constants
                  ****/ 
                  $GLOBALS['gbd']['gbdErrorMask'] = $gbdData;
                  break;
                  
               case '':
                  socket_set_timeout($GLOBALS['gbd']['gbdSocket'], 5, 0);
                  break;

               case 'wait':
              /****c* Client.to.Script/wait
                  * NAME
                  *    wait
                  *
                  * ARGS
                  *    none
                  *      
                  * DESCRIPTION
                  *     Tells te script to chill a bit
                  *
                  *     If in rundisplay mode, the client will tell the script to 'wait' then 'next' upon receiving a 'commandme'
                  *
                  * SEE ALSO
                  *
                  ****/ 
                  $gbdMicroTime = $GLOBALS['gbd']['displaydelay'] - (gbdGetmicrotime() - $gbdMicroTime);
                  if($gbdMicroTime > 0) {
                     if(function_exists('usleep'))
                        usleep($gbdMicroTime);
                     else
                        sleep($gbdMicroTime / 1000000);
                  }
                  break;
                  
               default:
                 gbdSendCommand("status", "Unknown command '{$gbdCommand}'");
            }
         }
         unset($gbdCommand);
      }
   }


   // This function is called first of all in eval() to indicate that parsing was ok
   function gbdSourceParsed($gbdScriptname) {
      unset($GLOBALS['gbd']['unparsed'][$gbdScriptname]);
      gbdSendCommand("parseok", gbdFixPath($gbdScriptname));
   }

   // If error handling is enabled, this function intercepts the error and sends info to the server,
   // then it awaits commands as usual
   function gbdHandleError($number, $text, $filename, $line, $vars) {
      //echo "<br>error...$number, $text, $filename, $line, $vars - {$GLOBALS['gbd']['gbdNoHalt']}<br>\n";
      
      if($GLOBALS['gbd']['gbdNoHalt'])
         return true;

      if($GLOBALS['gbd']['gbdLeap'] && !($GLOBALS['gbd']['gbdErrorMask'] & $number))
         return true;
         
      if(dirname($filename) == dirname(__FILE__))
         $filename = $GLOBALS['gbd']['gbdPrevScript'];

      gbdEmptyQueue();
      gbdSendCommand("error", gbdFixPath($filename) . ":{$line}:{$number}:".str_replace(':', ';', $text));

      // Wait for acknowlege
      $gbdCommand = "";
      while(!in_array($gbdCommand, Array("pause", "runnodisplay", "rundisplay"))) {
         $gbdCommand = trim(fgets($GLOBALS['gbd']['gbdSocket'], 256));
         if($gbdCommand != "")
            fgets($GLOBALS['gbd']['gbdSocket'], 256);
      }

      //echo "##" . $gbdCommand  ."<br>";
      if($gbdCommand != "pause")
         return;

      // Turn off leapmode if set..
      $GLOBALS['gbd']['gbdLeap'] = false;
      if(isset($GLOBALS['gbd']['gbdPhpOrigCode'][$filename]))
         return gbdGubed($filename, $line, $vars, '');

      return;
   }

   // This function is called at forced breakpoints
   function gbdHandleBreakPoint($gbdScriptname, $gbdLine, $gbdVars) {
      
      // Turn off leapmode if set...
      $GLOBALS['gbd']['gbdLeap'] = false;

      gbdEmptyQueue();
      gbdSendCommand("forcebreak", gbdFixPath($gbdScriptname) . ":{$gbdLine}");

      // Wait for acknowlege
      $gbdCommand = trim(fgets($GLOBALS['gbd']['gbdSocket'], 256));
      if($gbdCommand != "")
         $gbdData = trim(fgets($GLOBALS['gbd']['gbdSocket'], 256));

      gbdGubed($gbdScriptname, $gbdLine, $gbdVars, '');

      return;
   }


   // Send command
   function gbdSendCommand($gbdCommand, $gbdData) {
      $gbdData = $gbdCommand . ":" . strlen($gbdData) . ';' . $gbdData;
      fwrite($GLOBALS['gbd']['gbdSocket'], $gbdData);
   }
   
   // Empty the queue
   function gbdEmptyQueue() {
      socket_set_blocking($GLOBALS['gbd']['gbdSocket'], false);

      while(trim(fgets($GLOBALS['gbd']['gbdSocket'], 256)) != "");

      socket_set_blocking($GLOBALS['gbd']['gbdSocket'], true);

   }

   // Send info that we've reached the end
   function gbdQuit($gbdThisScript) {
      gbdSendCommand("end", gbdFixPath($gbdThisScript));
   }

   // Send info that we're all done
   function gbdFinalize() {
      gbdSendCommand("status", "All done");
      fflush($GLOBALS['gbd']['gbdSocket']);
      @fclose($GLOBALS['gbd']['gbdSocket']);
      
   }

   // Read file from disc
   function gbdReadScript($filename) {

      if(function_exists('file_get_contents'))
         return file_get_contents($filename, true);
         
      ob_start();
      $retval = @readfile(gbdFindFile($filename), true);
      if (false !== $retval)
         $retval = ob_get_contents();
      else
         $retval = "Unknown file: {$filename}";
      ob_end_clean();

      return $retval;

   }

   // From php.net, thanks: martijn at grendelman dot net
   // The function below checks the entire include_path for the file, but is altered to 
   // return found filename:
   function gbdFindFile($file) {
      
      if(substr($file,0,1) == DIRECTORY_SEPARATOR && file_exists($file)) 
        return $file;
   
      if(realpath($file) != '')
        return realpath($file);
        
      $incpath = ini_get("include_path");
      foreach (explode(":",$incpath) as $path) {
         if (file_exists($path.DIRECTORY_SEPARATOR.$file)) 
           return realpath($path.DIRECTORY_SEPARATOR.$file);
      }
      
      return $file;
  }

   function gbdCheckNoDebug($gbdScript) {
      if(!isset($GLOBALS['gbd']['gbdNoDebug']))
         return false;

      if(in_array($gbdScript, $GLOBALS['gbd']['gbdNoDebug']))
         return true;

      reset($GLOBALS['gbd']['gbdNoDebug']);
      while(list($k, $v) = each($GLOBALS['gbd']['gbdNoDebug']))
         if(substr($v, 0, 1) != '#' && preg_match("/$v/i", $gbdScript))
            return true;

      return false;
   }

   // This function does a rewritten header("Location: ...");
   function gbdRelocate($gbdLocation) {
      if(preg_match("/Location:\\s*.*:\\/\\/.*/", $gbdLocation)) {
         Header($gbdLocation);
         return;
      }
      $gbdLocation = str_replace('?', '&', $gbdLocation );
      $gbdLocation ='Location: ' 
                           . $GLOBALS['gbdStartSession'] 
                           . (substr($gbdLocation, strpos($gbdLocation, ':') + 2, 1) == '&' ? $GLOBALS['gbdScript'] : '')
                           . substr($gbdLocation, strpos($gbdLocation, ':') + 2);
       header($gbdLocation);
//        ob_flush();
//        die();
   }
   
   // From php.net/microtime
   function gbdFixPath($filepath){
      return $filepath;//str_replace('\\', '/', str_replace(':', '', $filepath));
   }
   
   // From php.net/microtime
   function gbdGetmicrotime(){
      list($usec, $sec) = explode(" ",microtime());
      return ((float)$usec + (float)$sec);
   }

   // Since PHP5 no longer includes $this in get_Defined_vars, we have a trick it by including a reference to the $this,
   // which in turns makes it available.. a bit hackish, perhaps...
   function gbdGet_defined_vars($vars1, $vars2) {
      if(isset($vars2))
         $vars1['gbdthis'] = $vars2;
      return $vars1;   
   }

   // First shutdown function called
   function gbdShutdown1() { //$gbdStartSession, $gbdSessionFile, $gbdScript, $gbdBaseURL) {
      if(count($GLOBALS['gbd']['unparsed']) > 0) {
         while(list($gbdK, $gbdV) = each($GLOBALS['gbd']['unparsed'])) {
            gbdSendCommand("parsefailed", gbdFixPath($gbdK));
         }
      }
      
      // Make sure it's the last one called...
      register_shutdown_function('gbdShutdown2');//, $gbdStartSession, $gbdSessionFile, $gbdScript, $gbdBaseURL);
   }
   
   // Last shutdownfunction called 
   function gbdShutdown2() { //$gbdStartSession, $gbdSessionFile, $gbdScript, $gbdBaseURL) {
      $output = isset($GLOBALS['gbd']['buffer']) ? $GLOBALS['gbd']['buffer'] : '';
//      Header('Content-Type: text/plain');       
//       echo strlen($output);
      if(ob_get_level() > 0) {
         $output .= ob_get_contents();
         ob_end_clean();
      }
//    echo ', ' . strlen($output);
//   echo $output; 
      // Replace all relative links and actions in $output
      if(strpos(strtolower($output), '<html')) {    
         preg_match_all("/<!--.*-->|<(\\/?[\\w]+)[^>]*>([^<]*)/", $output, $matches, PREG_PATTERN_ORDER);
         
   //        $output = print_r($matches, true);
         $attributes = Array('href', 'usemap', 'src', 'action', 'background', 'cite', 'classid', 'codebase', 'data', 'longdesc', 'profile');
   //       echo "<pre>";
         $addhidden = false;
         for($cnt = 0; $cnt < count($matches[0]); $cnt++) {
   //          echo htmlentities("{$matches[0][$cnt]}");
            foreach($attributes as $attribute) {
               $attribute = strtolower($attribute);
               preg_match_all("/(.*?){$attribute}\\s*=\\s*(\".*?\"|'.*?'|[^\"\'].+?\\s)(.*)/si", $matches[0][$cnt], $submatches, PREG_PATTERN_ORDER);
               if(count($submatches[0]) > 0) {
               
                  for($cnt2 = 0; $cnt2 < count($submatches[0]); $cnt2++) {
                     if(substr($submatches[2][$cnt2], 0, 1) == '"') {
                        $submatches[2][$cnt2] = substr($submatches[2][$cnt2], 1, strlen($submatches[2][$cnt2]) - 2);
                        $quote = '"';
                     } elseif(substr($submatches[2][$cnt2], 0, 1) == "'") {
                        $submatches[2][$cnt2] = substr($submatches[2][$cnt2], 1, strlen($submatches[2][$cnt2]) - 2);
                        $quote = "'";
                     } else
                        $quote = '';
                        
                     if(!preg_match("/^.+:\\/\\//", $submatches[2][$cnt2]) ) {
                        if($attribute == 'action' && $submatches[2][$cnt2] == '') {
                           $submatches[0][$cnt2] = "{$attribute}={$quote}http://" . $_SERVER['SERVER_NAME'] . $GLOBALS['gbd']['SessionFile'] . $quote;
                           $addhidden  = true;
                        } elseif(substr($submatches[2][$cnt2], 0, 1) == '?') {
                           $submatches[2][$cnt2]  = '&amp;' . substr($submatches[2][$cnt2], 1);
                           $submatches[0][$cnt2] ="{$attribute}={$quote}http://" . $_SERVER['SERVER_NAME'] . $GLOBALS['gbd']['StartSession'] . $GLOBALS['gbd']['Script'] . $submatches[2][$cnt2] . $quote ;
                        } elseif(preg_match("/.*\\.ph.{0,5}.*/i", $submatches[2][$cnt2])) {
                           $submatches[0][$cnt2] = "{$attribute}={$quote}http://" . $_SERVER['SERVER_NAME'] . $GLOBALS['gbd']['StartSession'] . $GLOBALS['gbd']['BaseURL'] .str_replace('?', '&', $submatches[2][$cnt2]) . $quote;
                           
                           if($attribute == 'action')
                              $addhidden  = true;
                        } else
                           $submatches[0][$cnt2] = "{$attribute}={$quote}http://" . $_SERVER['SERVER_NAME'] . $GLOBALS['gbd']['BaseURL'] . $submatches[2][$cnt2] . $quote;
                        $submatches[0][$cnt2] = $submatches[1][$cnt2] . $submatches[0][$cnt2] . $submatches[3][$cnt2];
                     }
                     
                     $matches[0][$cnt] = join('', $submatches[0]);
                     if($addhidden) {
                        $matches[0][$cnt]  .= "<input type=\"hidden\" name=\"gbdScript\" value=\"{$GLOBALS['gbd']['Script']}\" />";
                        $addhidden = false;
                     }
                  }
   //                 $submatches = print_r($submatches, true); 
   //                 echo htmlentities($submatches);
               }
            }
         
         }
      
//       echo htmlentities($output);
//       echo htmlentities(join("", $matches[0]));
//       print_r(headers_sent());
         echo join("", $matches[0]);
      } else
         echo $output;       
   }      
?>
