<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
   <head>
      <title>
         Welcome to Gubed
      </title>
   </head>
   <body>
      <h1>
         Gubed PHP Debugger
      </h1>
      <h2>
         Setup
      </h2>
      <p>
         This is a small introduction to Gubed PHP Debugger. To get started you'll need to:
      </p>
      <ul>
         <li>
            Install the <a href="http://wxwidgets.org">wxWidgets</a> client or get <a href="http://quanta.sf.net">Quanta</a> with Gubed support.
            <br />
            Installation instructions can be found in the docs/ subdirectory of the Gubed distribution archive (wxgubed.txt and quanta.txt)
         </li>
         <li>
            Copy the Gubed PHP directory structure so it's accessible to your webserver (if you can read this, chances are you've done this already). See 'serversetup.txt' in the docs/ subdirectory and <strong>make sure to read the security section!</strong>
         </li>
         <li>
            Optionally install and set up the proxy server, see proxysetup.txt
         </li>
         <li>Start the client and configure it (see installation instructions depending on what client you use)</li>
         <li>Open a browser and <a href="StartSession.php">specify script to debug</a> by going to the <a href="StartSession.php">StartSession.php</a> page</li>
      </ul>
      
      <h2>
         Gubed tests
      </h2>
      <p>
         To enter the Gubed testbench (a good start to explore Gubed's capabilities): 
         <!--a href="StartSession.php?gbdScript=<?=dirname($_SERVER['SCRIPT_NAME'])?>/GubedTest/index.php"-->
         <a href="GubedTest/index.php">
            <?=dirname($_SERVER['SCRIPT_NAME'])?>/GubedTest/index.php
         </a>
      </p>
      <h2>
         Debug scripts
      </h2>
      <p>
         To start debugging your own scripts, enter 
         <a href="StartSession.php">
            StartSession
         </a>
      </p>
      <h2>
         Developer aid
      </h2>
      <p>
         If you have problems with Gubed and wish to file a 
         <a href="http://sourceforge.net/tracker/?group_id=75605&atid=544513">bug report</a>
          or a 
          <a href="http://sourceforge.net/tracker/?group_id=75605&atid=544514">support request</a>,
          please visit the
         <a href="debuginfo.php">Debug Info Page</a>
         and submit the output along with your report.
      </p>
      <?php 
         if(is_dir('develop')) {
            ?>
               <p>
                  <strong>
                     You have the 'develop' subdirectory available. This is not a good thing if this webspace is accessible for anyone!
                  </strong>
               </p>
               <p>
                  You can delete the directory from the Gubed subdirectory, or use it to to test the parser:
                  <a href="develop/regexptest.php">
                     ./develop/regexptest.php
                  </a>
                  (if this page lists errors, please report them if the file is really parsable by php!)
               </p>
            <?
         }
      ?>
      <h2>
         More info
      </h2>      
      <p>
         Visut Gubed website:
         <a href="http://gubed.sf.net/">
            http://gubed.sf.net/
        </a>
      </p>
   </body>
</html>
